import shutil
from abc import ABC, abstractmethod
from pathlib import Path
import os


class BaseSaver(ABC):
    _sav_path = os.getenv('SAVER_DIR', 'sav')

    @abstractmethod
    def save(self) -> Path:
        pass

    @abstractmethod
    def _check_if_computer_have_dependency(self) -> bool:
        pass

    @classmethod
    def _get_dir_save_path(cls) -> Path:
        return Path.joinpath(Path.cwd(), cls._sav_path)

    @staticmethod
    def _initialize_dir(path: Path) -> None:
        if os.path.exists(path):
            shutil.rmtree(path)
        os.makedirs(path)